| Version: 3.3.1

Public Member Functions | Static Public Member Functions | List of all members
wxWebView Class Referenceabstract
Class List by Category » Controls | Class List by Category » WebView

`#include <wx/webview.h>`

Inheritance diagram for wxWebView:
[legend]

## Detailed Description

This control may be used to render web (HTML / CSS / JavaScript) documents.

It is designed to allow the creation of multiple backends for each port. It differs from wxHtmlWindow in that each backend is actually a full web engine, provided by a 3rd party (e.g., WebView2 on MSW or WebKit on macOS and GTK). This allows the correct viewing of complex pages with JavaScript and CSS.

# Backend Descriptions

This class supports using multiple backends, corresponding to different implementations of the same functionality. wxWebViewChrome is available on all three major platforms and each platform also has its own default native backend. Backends are identified by their names, documented in the backend descriptions below.

## wxWEBVIEW_BACKEND_IE (MSW)

The IE backend uses Microsoft's WebBrowser control, which depends the locally installed version of Internet Explorer. By default this backend emulates Internet Explorer 7. This can be changed with a registry setting by wxWebViewIE::MSWSetEmulationLevel() see this article for more information.

This backend has full support for custom schemes and virtual file systems.

The predefined `wxWebViewBackendIE` constant contains the name of this backend and can be used to explicitly select it when using wxWebView::New().

Note
  If you plan to display any modern web content you should consider using wxWEBVIEW_BACKEND_EDGE (MSW), as Internet Explorer is not supported anymore by Microsoft.

## wxWEBVIEW_BACKEND_EDGE (MSW)

The Edge backend uses Microsoft's Edge WebView2. It is available for Windows 7 (newer versions require Windows 10+) and newer.

This backend does not support custom schemes. When using handlers, see wxWebViewHandler::SetVirtualHost() for more details on how to access handler provided URLs.

This backend is enabled by default only when using CMake. To build it follow these steps:

- When not using CMake:
  - Download the WebView2 SDK NuGet package (Version 1.0.864.35 or newer)
  - Extract the package (it's a zip archive) to `WX_SRCDIR/3rdparty/webview2` (you should have `3rdparty/webview2/build/native/include/WebView2.h` file after unpacking it)
  - Enable `wxUSE_WEBVIEW_EDGE` in `setup.h`
- When using CMake, the backend is enabled by default. It can be disabled by setting `wxUSE_WEBVIEW_EDGE` to `OFF`. If a WebView2 SDK is found in `WX_SRCDIR/3rdparty/webview2` (see the bullet above), that SDK is used. Otherwise, the SDK is downloaded and extracted by CMake during the configure phase (into directory `WX_BUILDDIR/libs/webview/packages`)
- Build wxWidgets webview library
- From the WebView2 SDK `build` subdirectory copy `WebView2Loader.dll` corresponding to the architecture used (x86 or x64) to the directory with your application executable
- At runtime you can use wxWebView::IsBackendAvailable() to check if the backend can be used (it will be available if `WebView2Loader.dll` can be loaded and Edge (Chromium) is installed)
- Make sure to add a note about using the WebView2 SDK to your application documentation, as required by its licence
- With Visual Studio 2019 or newer `wxUSE_WEBVIEW_EDGE_STATIC` can be used to static link the loader and remove the dependency on `WebView2Loader.dll` at runtime.

If enabled and available at runtime, Edge will be selected as the default backend. If you require the IE backend use `wxWebViewBackendIE` when using wxWebView::New().

If your application should use a fixed version of the WebView2 runtime you must use wxWebViewEdge::MSWSetBrowserExecutableDir() to specify its usage before using the Edge backend.

The predefined `wxWebViewBackendEdge` constant contains the name of this backend.

## wxWEBVIEW_WEBKIT (GTK)

Under GTK the WebKit backend uses WebKitGTK+. The current minimum version required is 1.3.1 which ships by default with Ubuntu Natty and Debian Wheezy and has the package name libwebkitgtk-dev.

Custom schemes and virtual files systems are supported under this backend, however embedded resources such as images and stylesheets are currently loaded using the data:// scheme.

The predefined `wxWebViewBackendWebKit` constant contains the name of this backend.

## wxWEBVIEW_WEBKIT2 (GTK3)

Under GTK3 the WebKit2 version of WebKitGTK+ is used. In Ubuntu the required package name is libwebkit2gtk-4.0-dev and under Fedora it is webkitgtk4-devel.

All features are supported except for clearing and enabling / disabling the history.

The predefined `wxWebViewBackendWebKit` constant contains the name of this backend.

## wxWEBVIEW_WEBKIT (macOS)

The macOS WebKit backend uses Apple's WKWebView class.

This backend has full support for custom schemes and virtual file systems on macOS 10.13+. In order to use handlers, two-step creation has to be used and RegisterHandler() has to be called before Create().

Starting with macOS 10.11 and iOS 9 an application cannot create unsecure connections (this includes HTTP and unverified HTTPS). You have to include additional fields in your Info.plist to enable such connections. For further details see the documentation on NSAppTransportSecurity here

The predefined `wxWebViewBackendWebKit` constant contains the name of this backend.

## wxWEBVIEW_CHROMIUM (MSW, macOS, GTK)

The Chromium Embedded Framework backend has to be enabled when building wxWidgets, see wxWebViewChromium for additional usage and build instructions.

The predefined `wxWebViewBackendChromium` constant contains the name of this backend.

# Asynchronous Notifications

Many of the methods in wxWebView are asynchronous, i.e. they return immediately and perform their work in the background. This includes functions such as LoadURL() and Reload(). To receive notification of the progress and completion of these functions you need to handle the events that are provided. Specifically `wxEVT_WEBVIEW_LOADED` notifies when the page or a sub-frame has finished loading and `wxEVT_WEBVIEW_ERROR` notifies that an error has occurred.

# Virtual File Systems and Custom Schemes

wxWebView supports the registering of custom scheme handlers, for example `file` or `http`. To do this create a new class which inherits from wxWebViewHandler, where wxWebViewHandler::GetFile() returns a pointer to a wxFSFile which represents the given url or wxWebViewHandler::StartRequest() for more complex requests. You can then register your handler with RegisterHandler() it will be called for all pages and resources.

wxWebViewFSHandler is provided to access the virtual file system encapsulated by wxFileSystem. The wxMemoryFSHandler documentation gives an example of how this may be used.

wxWebViewArchiveHandler is provided to allow the navigation of pages inside a zip archive. It supports paths of the form: `scheme:///C:/example/docs.zip;protocol=zip/main.htm`

## Events emitted by this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxWebViewEvent& event)

Event macros for events emitted by this class:

- EVT_WEBVIEW_CREATED(id, func):
  Process a `wxEVT_WEBVIEW_CREATED` event, generated when the object is fully initialized. For the backends using asynchronous initialization, such as wxWebViewChromium, most of this class member functions can be only used once this event is received. Available only in wxWidgets 3.3.0 or later.
- EVT_WEBVIEW_NAVIGATING(id, func):
  Process a `wxEVT_WEBVIEW_NAVIGATING` event, generated before trying to get a resource. This event may be vetoed to prevent navigating to this resource. Note that if the displayed HTML document has several frames, one such event will be generated per frame.
- EVT_WEBVIEW_NAVIGATED(id, func):
  Process a `wxEVT_WEBVIEW_NAVIGATED` event generated after it was confirmed that a resource would be requested. This event may not be vetoed. Note that if the displayed HTML document has several frames, one such event will be generated per frame.
- EVT_WEBVIEW_LOADED(id, func):
  Process a `wxEVT_WEBVIEW_LOADED` event generated when the document is fully loaded and displayed. Note that if the displayed HTML document has several frames, one such event will be generated per frame.
- EVT_WEBVIEW_ERROR(id, func):
  Process a `wxEVT_WEBVIEW_ERROR` event generated when a navigation error occurs. The integer associated with this event will be a wxWebNavigationError item. The string associated with this event may contain a backend-specific more precise error message/code.
- EVT_WEBVIEW_NEWWINDOW(id, func):
  Process a `wxEVT_WEBVIEW_NEWWINDOW` event, generated when a new window is created. You must handle this event if you want anything to happen, for example to load the page in a new window or tab. For usage details see wxWebViewWindowFeatures.
- EVT_WEBVIEW_NEWWINDOW_FEATURES(id, func):
  Process a `wxEVT_WEBVIEW_NEWWINDOW_FEATURES` event, generated when window features are available for the new window. For usage details see wxWebViewWindowFeatures. Available only in wxWidgets 3.3.0 or later.
- EVT_WEBVIEW_WINDOW_CLOSE_REQUESTED(id, func):
  Process a `wxEVT_WEBVIEW_WINDOW_CLOSE_REQUESTED` event, generated when a window is requested to be closed. Available only in wxWidgets 3.3.0 or later.
- EVT_WEBVIEW_TITLE_CHANGED(id, func):
  Process a `wxEVT_WEBVIEW_TITLE_CHANGED` event, generated when the page title changes. Use GetString to get the title.
- EVT_WEBVIEW_FULLSCREEN_CHANGED(id, func):
  Process a `wxEVT_WEBVIEW_FULLSCREEN_CHANGED` event, generated when the page wants to enter or leave fullscreen. Use GetInt to get the status. Not implemented for the IE backend. Available only in wxWidgets 3.1.5 or later.
- EVT_WEBVIEW_SCRIPT_MESSAGE_RECEIVED(id, func):
  Process a `wxEVT_WEBVIEW_SCRIPT_MESSAGE_RECEIVED` event. Available only in wxWidgets 3.1.5 or later. For usage details see AddScriptMessageHandler().
- EVT_WEBVIEW_SCRIPT_RESULT(id, func):
  Process a `wxEVT_WEBVIEW_SCRIPT_RESULT` event. Available only in wxWidgets 3.1.6 or later. For usage details see RunScriptAsync().
- wxEVT_WEBVIEW_BROWSING_DATA_CLEARED(id, func):
  Process a `wxEVT_WEBVIEW_BROWSING_DATA_CLEARED` event only available in wxWidgets 3.3.0 or later. For usage details see ClearBrowsingData().

Since
  2.9.3

  ##

Library: wxWebView
Category: Controls, WebView

See also
  wxWebViewEvent, wxWebViewConfiguration, wxWebViewHandler

## Public Member Functions
virtual bool | Create (wxWindow *parent, wxWindowID id, const wxString &url=wxWebViewDefaultURLStr, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxWebViewNameStr)=0
| Creation function for two-step creation. More...
virtual wxString | GetCurrentTitle () const =0
| Get the title of the current web page, or its URL/path if title is not available. More...
virtual wxString | GetCurrentURL () const =0
| Get the URL of the currently displayed document. More...
virtual void * | GetNativeBackend () const =0
| Return the pointer to the native backend used by this control. More...
virtual wxString | GetPageSource () const
| Get the HTML source code of the currently displayed document. More...
virtual wxString | GetPageText () const
| Get the text of the current page. More...
virtual bool | IsBusy () const =0
| Returns whether the web control is currently busy (e.g. loading a page). More...
virtual bool | IsEditable () const =0
| Returns whether the web control is currently editable. More...
virtual void | LoadURL (const wxString &url)=0
| Load a web page from a URL. More...
virtual void | Print ()=0
| Opens a print dialog so that the user may print the currently displayed page. More...
virtual void | RegisterHandler (wxSharedPtr< wxWebViewHandler > handler)=0
| Registers a custom scheme handler. More...
virtual void | Reload (wxWebViewReloadFlags flags=wxWEBVIEW_RELOAD_DEFAULT)=0
| Reload the currently displayed URL. More...
virtual void | SetEditable (bool enable=true)=0
| Set the editable property of the web control. More...
virtual void | SetPage (const wxString &html, const wxString &baseUrl)=0
| Set the displayed page source to the contents of the given string. More...
virtual void | SetPage (wxInputStream &html, wxString baseUrl)
| Set the displayed page source to the contents of the given stream. More...
virtual void | Stop ()=0
| Stop the current page loading process, if any. More...
virtual bool | SetUserAgent (const wxString &userAgent)
| Specify a custom user agent string for the web view. More...
virtual wxString | GetUserAgent () const
| Returns the current user agent string for the web view. More...
virtual bool | SetProxy (const wxString &proxy)
| Set the proxy to use for all requests. More...
virtual bool | ClearBrowsingData (int types=wxWEBVIEW_BROWSING_DATA_ALL, wxDateTime since={})
| Clears the browsing data of the web view. More...
Scripting
virtual bool | RunScript (const wxString &javascript, wxString *output=nullptr) const =0
| Runs the given JavaScript code. More...
virtual void | RunScriptAsync (const wxString &javascript, void *clientData=nullptr) const
| Runs the given JavaScript code asynchronously and returns the result via a `wxEVT_WEBVIEW_SCRIPT_RESULT`. More...
virtual bool | AddScriptMessageHandler (const wxString &name)
| Add a script message handler with the given name. More...
virtual bool | RemoveScriptMessageHandler (const wxString &name)
| Remove a script message handler with the given name that was previously added via AddScriptMessageHandler(). More...
virtual bool | AddUserScript (const wxString &javascript, wxWebViewUserScriptInjectionTime injectionTime=wxWEBVIEW_INJECT_AT_DOCUMENT_START)
| Injects the specified script into the webpage's content. More...
virtual void | RemoveAllUserScripts ()
| Removes all user scripts from the web view. More...
Clipboard
virtual bool | CanCopy () const
| Returns true if the current selection can be copied. More...
virtual bool | CanCut () const
| Returns true if the current selection can be cut. More...
virtual bool | CanPaste () const
| Returns true if data can be pasted. More...
virtual void | Copy ()
| Copies the current selection. More...
virtual void | Cut ()
| Cuts the current selection. More...
virtual void | Paste ()
| Pastes the current data. More...
Settings
virtual void | EnableContextMenu (bool enable=true)
| Enable or disable the right click context menu. More...
virtual bool | IsContextMenuEnabled () const
| Returns true if a context menu will be shown on right click. More...
virtual void | EnableAccessToDevTools (bool enable=true)
| Enable or disable access to dev tools for the user. More...
virtual bool | IsAccessToDevToolsEnabled () const
| Returns true if dev tools are available to the user. More...
virtual bool | ShowDevTools ()
| Show the dev tools window. More...
virtual void | EnableBrowserAcceleratorKeys (bool enable=true)
| Enable or disable if browser accelerator keys are enabled. More...
virtual bool | AreBrowserAcceleratorKeysEnabled () const
| Returns true if browser accelerator keys are enabled. More...
History
virtual bool | CanGoBack () const =0
| Returns true if it is possible to navigate backward in the history of visited pages. More...
virtual bool | CanGoForward () const =0
| Returns true if it is possible to navigate forward in the history of visited pages. More...
virtual void | ClearHistory ()=0
| Clear the history, this will also remove the visible page. More...
virtual void | EnableHistory (bool enable=true)=0
| Enable or disable the history. More...
virtual wxVector< wxSharedPtr< wxWebViewHistoryItem > > | GetBackwardHistory ()=0
| Returns a list of items in the back history. More...
virtual wxVector< wxSharedPtr< wxWebViewHistoryItem > > | GetForwardHistory ()=0
| Returns a list of items in the forward history. More...
virtual void | GoBack ()=0
| Navigate back in the history of visited pages. More...
virtual void | GoForward ()=0
| Navigate forward in the history of visited pages. More...
virtual void | LoadHistoryItem (wxSharedPtr< wxWebViewHistoryItem > item)=0
| Loads a history item. More...
Selection
virtual void | ClearSelection ()
| Clears the current selection. More...
virtual void | DeleteSelection ()
| Deletes the current selection. More...
virtual wxString | GetSelectedSource () const
| Returns the currently selected source, if any. More...
virtual wxString | GetSelectedText () const
| Returns the currently selected text, if any. More...
virtual bool | HasSelection () const
| Returns true if there is a current selection. More...
virtual void | SelectAll ()
| Selects the entire page. More...
Undo / Redo
virtual bool | CanRedo () const =0
| Returns true if there is an action to redo. More...
virtual bool | CanUndo () const =0
| Returns true if there is an action to undo. More...
virtual void | Redo ()=0
| Redos the last action. More...
virtual void | Undo ()=0
| Undos the last action. More...
Finding
virtual long | Find (const wxString &text, wxWebViewFindFlags flags=wxWEBVIEW_FIND_DEFAULT)
| Finds a phrase on the current page and if found, the control will scroll the phrase into view and select it. More...
Zoom
virtual bool | CanSetZoomType (wxWebViewZoomType type) const =0
| Retrieve whether a zoom type is supported. More...
virtual wxWebViewZoom | GetZoom () const
| Get the zoom level of the page. More...
virtual float | GetZoomFactor () const =0
| Get the zoom factor of the page. More...
virtual wxWebViewZoomType | GetZoomType () const =0
| Get how the zoom factor is currently interpreted. More...
virtual void | SetZoom (wxWebViewZoom zoom)
| Set the zoom level of the page. More...
virtual void | SetZoomFactor (float zoom)=0
| Set the zoom factor of the page. More...
virtual void | SetZoomType (wxWebViewZoomType zoomType)=0
| Set how to interpret the zoom factor. More...
Public Member Functions inherited from wxControl
| wxControl (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxValidator &validator=wxDefaultValidator, const wxString &name=wxControlNameStr)
| Constructs a control. More...
| wxControl ()
| Default constructor to allow 2-phase creation. More...
bool | Create (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxValidator &validator=wxDefaultValidator, const wxString &name=wxControlNameStr)
virtual void | Command (wxCommandEvent &event)
| Simulates the effect of the user issuing a command to the item. More...
wxString | GetLabel () const
| Returns the control's label, as it was passed to SetLabel(). More...
wxString | GetLabelText () const
| Returns the control's label without mnemonics. More...
wxSize | GetSizeFromTextSize (int xlen, int ylen=-1) const
| Determine the size needed by the control to leave the given area for its text. More...
wxSize | GetSizeFromTextSize (const wxSize &tsize) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
wxSize | GetSizeFromText (const wxString &text) const
| Determine the minimum size needed by the control to display the given text. More...
void | SetLabel (const wxString &label)
| Sets the control's label. More...
void | SetLabelText (const wxString &text)
| Sets the control's label to exactly the given string. More...
bool | SetLabelMarkup (const wxString &markup)
| Sets the controls label to a string using markup. More...
Public Member Functions inherited from wxWindow
| wxWindow ()
| Default constructor. More...
| wxWindow (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxPanelNameStr)
| Constructs a window, which can be a child of a frame, dialog or any other non-control window. More...
virtual | ~wxWindow ()
| Destructor. More...
bool | Create (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxPanelNameStr)
| Construct the actual window object after creating the C++ object. More...
void | MSWDisableComposited ()
| Disable the use native double buffering in wxMSW. More...
virtual bool | AcceptsFocus () const
| This method may be overridden in the derived classes to return false to indicate that this control doesn't accept input at all (i.e. behaves like e.g. wxStaticText) and so doesn't need focus. More...
virtual bool | AcceptsFocusFromKeyboard () const
| This method may be overridden in the derived classes to return false to indicate that while this control can, in principle, have focus if the user clicks it with the mouse, it shouldn't be included in the TAB traversal chain when using the keyboard. More...
virtual bool | AcceptsFocusRecursively () const
| Overridden to indicate whether this window or one of its children accepts focus. More...
void | DisableFocusFromKeyboard ()
| Disable giving focus to this window using the keyboard navigation keys. More...
bool | IsFocusable () const
| Can this window itself have focus? More...
bool | CanAcceptFocus () const
| Can this window have focus right now? More...
bool | CanAcceptFocusFromKeyboard () const
| Can this window be assigned focus from keyboard right now? More...
virtual bool | HasFocus () const
| Returns true if the window (or in case of composite controls, its main child window) has focus. More...
virtual void | SetCanFocus (bool canFocus)
| This method is only implemented by ports which have support for native TAB traversal (such as GTK+ 2.0). More...
virtual void | EnableVisibleFocus (bool enable)
| Enables or disables visible indication of keyboard focus. More...
virtual void | SetFocus ()
| This sets the window to receive keyboard input. More...
virtual void | SetFocusFromKbd ()
| This function is called by wxWidgets keyboard navigation code when the user gives the focus to this window from keyboard (e.g. using `TAB` key). More...
virtual void | AddChild (wxWindow *child)
| Adds a child window. More...
template<typename T >
void | CallForEachChild (const T &functor)
| Invoke the given functor for all children of the given window recursively. More...
bool | DestroyChildren ()
| Destroys all children of a window. More...
wxWindow * | FindWindow (long id) const
| Find a child of this window, by id. More...
wxWindow * | FindWindow (const wxString &name) const
| Find a child of this window, by name. More...
wxWindowList & | GetChildren ()
| Returns a reference to the list of the window's children. More...
const wxWindowList & | GetChildren () const
| Returns a const reference to the list of the window's children. More...
virtual void | RemoveChild (wxWindow *child)
| Removes a child window. More...
wxWindow * | GetGrandParent () const
| Returns the grandparent of a window, or nullptr if there isn't one. More...
wxWindow * | GetNextSibling () const
| Returns the next window after this one among the parent's children or nullptr if this window is the last child. More...
wxWindow * | GetParent () const
| Returns the parent of the window, or nullptr if there is no parent. More...
wxWindow * | GetPrevSibling () const
| Returns the previous window before this one among the parent's children or `` nullptr if this window is the first child. More...
bool | IsDescendant (wxWindow *win) const
| Check if the specified window is a descendant of this one. More...
virtual bool | Reparent (wxWindow *newParent)
| Reparents the window, i.e. the window will be removed from its current parent window (e.g. More...
virtual void | AlwaysShowScrollbars (bool hflag=true, bool vflag=true)
| Call this function to force one or both scrollbars to be always shown, even if the window is big enough to show its entire contents without scrolling. More...
virtual int | GetScrollPos (int orientation) const
| Returns the built-in scrollbar position. More...
virtual int | GetScrollRange (int orientation) const
| Returns the built-in scrollbar range. More...
virtual int | GetScrollThumb (int orientation) const
| Returns the built-in scrollbar thumb size. More...
bool | CanScroll (int orient) const
| Returns true if this window can have a scroll bar in this orientation. More...
bool | HasScrollbar (int orient) const
| Returns true if this window currently has a scroll bar for this orientation. More...
virtual bool | IsScrollbarAlwaysShown (int orient) const
| Return whether a scrollbar is always shown. More...
virtual bool | ScrollLines (int lines)
| Scrolls the window by the given number of lines down (if lines is positive) or up. More...
virtual bool | ScrollPages (int pages)
| Scrolls the window by the given number of pages down (if pages is positive) or up. More...
virtual void | ScrollWindow (int dx, int dy, const wxRect *rect=nullptr)
| Physically scrolls the pixels in the window and move child windows accordingly. More...
bool | LineUp ()
| Same as ScrollLines (-1). More...
bool | LineDown ()
| Same as ScrollLines (1). More...
bool | PageUp ()
| Same as ScrollPages (-1). More...
bool | PageDown ()
| Same as ScrollPages (1). More...
virtual void | SetScrollPos (int orientation, int pos, bool refresh=true)
| Sets the position of one of the built-in scrollbars. More...
virtual void | SetScrollbar (int orientation, int position, int thumbSize, int range, bool refresh=true)
| Sets the scrollbar properties of a built-in scrollbar. More...
void | Center (int dir=wxBOTH)
| A synonym for Centre(). More...
void | CenterOnParent (int dir=wxBOTH)
| A synonym for CentreOnParent(). More...
void | Centre (int direction=wxBOTH)
| Centres the window. More...
void | CentreOnParent (int direction=wxBOTH)
| Centres the window on its parent. More...
void | GetPosition (int *x, int *y) const
| This gets the position of the window in pixels, relative to the parent window for the child windows or relative to the display origin for the top level windows. More...
wxPoint | GetPosition () const
| This gets the position of the window in pixels, relative to the parent window for the child windows or relative to the display origin for the top level windows. More...
wxRect | GetRect () const
| Returns the position and size of the window as a wxRect object. More...
void | GetScreenPosition (int *x, int *y) const
| Returns the window position in screen coordinates, whether the window is a child window or a top level one. More...
wxPoint | GetScreenPosition () const
| Returns the window position in screen coordinates, whether the window is a child window or a top level one. More...
wxRect | GetScreenRect () const
| Returns the position and size of the window on the screen as a wxRect object. More...
virtual wxPoint | GetClientAreaOrigin () const
| Get the origin of the client area of the window relative to the window top left corner (the client area may be shifted because of the borders, scrollbars, other decorations...) More...
wxRect | GetClientRect () const
| Get the client rectangle in window (i.e. client) coordinates. More...
void | Move (int x, int y, int flags=wxSIZE_USE_EXISTING)
| Moves the window to the given position. More...
void | Move (const wxPoint &pt, int flags=wxSIZE_USE_EXISTING)
| Moves the window to the given position. More...
void | SetPosition (const wxPoint &pt)
| Moves the window to the specified position. More...
void | ClientToScreen (int *x, int *y) const
| Converts to screen coordinates from coordinates relative to this window. More...
wxPoint | ClientToScreen (const wxPoint &pt) const
| Converts to screen coordinates from coordinates relative to this window. More...
wxPoint | ConvertDialogToPixels (const wxPoint &pt) const
| Converts a point or size from dialog units to pixels. More...
wxSize | ConvertDialogToPixels (const wxSize &sz) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
wxPoint | ConvertPixelsToDialog (const wxPoint &pt) const
| Converts a point or size from pixels to dialog units. More...
wxSize | ConvertPixelsToDialog (const wxSize &sz) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
void | ScreenToClient (int *x, int *y) const
| Converts from screen to client window coordinates. More...
wxPoint | ScreenToClient (const wxPoint &pt) const
| Converts from screen to client window coordinates. More...
virtual void | ClearBackground ()
| Clears the window by filling it with the current background colour. More...
void | Freeze ()
| Freezes the window or, in other words, prevents any updates from taking place on screen, the window is not redrawn at all. More...
void | Thaw ()
| Re-enables window updating after a previous call to Freeze(). More...
bool | IsFrozen () const
| Returns true if the window is currently frozen by a call to Freeze(). More...
wxColour | GetBackgroundColour () const
| Returns the background colour of the window. More...
virtual wxBackgroundStyle | GetBackgroundStyle () const
| Returns the background style of the window. More...
virtual int | GetCharHeight () const
| Returns the character height for this window. More...
virtual int | GetCharWidth () const
| Returns the average character width for this window. More...
virtual wxVisualAttributes | GetDefaultAttributes () const
| Currently this is the same as calling wxWindow::GetClassDefaultAttributes(wxWindow::GetWindowVariant()). More...
virtual wxSize | GetDPI () const
| Return the DPI of the display used by this window. More...
wxFont | GetFont () const
| Returns the font for this window. More...
wxColour | GetForegroundColour () const
| Returns the foreground colour of the window. More...
void | GetTextExtent (const wxString &string, int *w, int *h, int *descent=nullptr, int *externalLeading=nullptr, const wxFont *font=nullptr) const
| Gets the dimensions of the string as it would be drawn on the window with the currently selected font. More...
wxSize | GetTextExtent (const wxString &string) const
| Gets the dimensions of the string as it would be drawn on the window with the currently selected font. More...
const wxRegion & | GetUpdateRegion () const
| Returns the region specifying which parts of the window have been damaged. More...
wxRect | GetUpdateClientRect () const
| Get the update rectangle bounding box in client coords. More...
virtual bool | HasTransparentBackground ()
| Returns true if this window background is transparent (as, for example, for wxStaticText) and should show the parent window background. More...
virtual void | Refresh (bool eraseBackground=true, const wxRect *rect=nullptr)
| Causes this window, and all of its children recursively, to be repainted. More...
void | RefreshRect (const wxRect &rect, bool eraseBackground=true)
| Redraws the contents of the given rectangle: only the area inside it will be repainted. More...
virtual void | Update ()
| Immediately repaints the invalidated area of the window and all of its children recursively. More...
virtual bool | SetBackgroundColour (const wxColour &colour)
| Sets the background colour of the window. More...
virtual bool | SetBackgroundStyle (wxBackgroundStyle style)
| Sets the background style of the window. More...
virtual bool | IsTransparentBackgroundSupported (wxString *reason=nullptr) const
| Checks whether using transparent background might work. More...
virtual bool | SetFont (const wxFont &font)
| Sets the font for this window. More...
virtual bool | SetForegroundColour (const wxColour &colour)
| Sets the foreground colour of the window. More...
void | SetOwnBackgroundColour (const wxColour &colour)
| Sets the background colour of the window but prevents it from being inherited by the children of this window. More...
bool | InheritsBackgroundColour () const
| Return true if this window inherits the background colour from its parent. More...
bool | UseBgCol () const
| Return true if a background colour has been set for this window. More...
bool | UseBackgroundColour () const
| Return true if a background colour has been set for this window. More...
void | SetOwnFont (const wxFont &font)
| Sets the font of the window but prevents it from being inherited by the children of this window. More...
void | SetOwnForegroundColour (const wxColour &colour)
| Sets the foreground colour of the window but prevents it from being inherited by the children of this window. More...
bool | UseForegroundColour () const
| Return true if a foreground colour has been set for this window. More...
bool | InheritsForegroundColour () const
| Return true if this window inherits the foreground colour from its parent. More...
void | SetPalette (const wxPalette &pal)
virtual bool | ShouldInheritColours () const
| Return true from here to allow the colours of this window to be changed by InheritAttributes(). More...
virtual void | SetThemeEnabled (bool enable)
| This function tells a window if it should use the system's "theme" code to draw the windows' background instead of its own background drawing code. More...
virtual bool | GetThemeEnabled () const
| Returns true if the window uses the system theme for drawing its background. More...
virtual bool | CanSetTransparent ()
| Returns true if the system supports transparent windows and calling SetTransparent() may succeed. More...
virtual bool | SetTransparent (wxByte alpha)
| Set the transparency of the window. More...
wxEvtHandler * | GetEventHandler () const
| Returns the event handler for this window. More...
bool | HandleAsNavigationKey (const wxKeyEvent &event)
| This function will generate the appropriate call to Navigate() if the key event is one normally used for keyboard navigation and return true in this case. More...
bool | HandleWindowEvent (wxEvent &event) const
| Shorthand for: More...
bool | ProcessWindowEvent (wxEvent &event)
| Convenient wrapper for ProcessEvent(). More...
bool | ProcessWindowEventLocally (wxEvent &event)
| Wrapper for wxEvtHandler::ProcessEventLocally(). More...
wxEvtHandler * | PopEventHandler (bool deleteHandler=false)
| Removes and returns the top-most event handler on the event handler stack. More...
void | PushEventHandler (wxEvtHandler *handler)
| Pushes this event handler onto the event stack for the window. More...
bool | RemoveEventHandler (wxEvtHandler *handler)
| Find the given handler in the windows event handler stack and removes (but does not delete) it from the stack. More...
void | SetEventHandler (wxEvtHandler *handler)
| Sets the event handler for this window. More...
virtual void | SetNextHandler (wxEvtHandler *handler)
| wxWindows cannot be used to form event handler chains; this function thus will assert when called. More...
virtual void | SetPreviousHandler (wxEvtHandler *handler)
| wxWindows cannot be used to form event handler chains; this function thus will assert when called. More...
long | GetExtraStyle () const
| Returns the extra style bits for the window. More...
virtual long | GetWindowStyleFlag () const
| Gets the window style that was passed to the constructor or Create() method. More...
long | GetWindowStyle () const
| See GetWindowStyleFlag() for more info. More...
bool | HasExtraStyle (int exFlag) const
| Returns true if the window has the given exFlag bit set in its extra styles. More...
bool | HasFlag (int flag) const
| Returns true if the window has the given flag bit set. More...
virtual void | SetExtraStyle (long exStyle)
| Sets the extra style bits for the window. More...
virtual void | SetWindowStyleFlag (long style)
| Sets the style of the window. More...
void | SetWindowStyle (long style)
| See SetWindowStyleFlag() for more info. More...
bool | ToggleWindowStyle (int flag)
| Turns the given flag on if it's currently turned off and vice versa. More...
void | MoveAfterInTabOrder (wxWindow *win)
| Moves this window in the tab navigation order after the specified win. More...
void | MoveBeforeInTabOrder (wxWindow *win)
| Same as MoveAfterInTabOrder() except that it inserts this window just before win instead of putting it right after it. More...
bool | Navigate (int flags=wxNavigationKeyEvent::IsForward)
| Performs a keyboard navigation action starting from this window. More...
bool | NavigateIn (int flags=wxNavigationKeyEvent::IsForward)
| Performs a keyboard navigation action inside this window. More...
virtual void | Lower ()
| Lowers the window to the bottom of the window hierarchy (Z-order). More...
virtual void | Raise ()
| Raises the window to the top of the window hierarchy (Z-order). More...
bool | Hide ()
| Equivalent to calling wxWindow::Show(false). More...
virtual bool | HideWithEffect (wxShowEffect effect, unsigned int timeout=0)
| This function hides a window, like Hide(), but using a special visual effect if possible. More...
bool | IsEnabled () const
| Returns true if the window is enabled, i.e. if it accepts user input, false otherwise. More...
bool | IsExposed (int x, int y) const
| Returns true if the given point or rectangle area has been exposed since the last repaint. More...
bool | IsExposed (wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
bool | IsExposed (int x, int y, int w, int h) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
bool | IsExposed (wxRect &rect) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
virtual bool | IsShown () const
| Returns true if the window is shown, false if it has been hidden. More...
virtual bool | IsShownOnScreen () const
| Returns true if the window is physically visible on the screen, i.e. it is shown and all its parents up to the toplevel window are shown as well. More...
bool | Disable ()
| Disables the window. More...
virtual bool | Enable (bool enable=true)
| Enable or disable the window for user input. More...
virtual bool | Show (bool show=true)
| Shows or hides the window. More...
virtual bool | ShowWithEffect (wxShowEffect effect, unsigned int timeout=0)
| This function shows a window, like Show(), but using a special visual effect if possible. More...
wxString | GetHelpText () const
| Gets the help text to be used as context-sensitive help for this window. More...
void | SetHelpText (const wxString &helpText)
| Sets the help text to be used as context-sensitive help for this window. More...
virtual wxString | GetHelpTextAtPoint (const wxPoint &point, wxHelpEvent::Origin origin) const
| Gets the help text to be used as context-sensitive help for this window. More...
wxToolTip * | GetToolTip () const
| Get the associated tooltip or nullptr if none. More...
wxString | GetToolTipText () const
| Get the text of the associated tooltip or empty string if none. More...
void | SetToolTip (const wxString &tipString)
| Attach a tooltip to the window. More...
void | SetToolTip (wxToolTip *tip)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
void | UnsetToolTip ()
| Unset any existing tooltip. More...
int | GetPopupMenuSelectionFromUser (wxMenu &menu, const wxPoint &pos=wxDefaultPosition)
| This function shows a popup menu at the given position in this window and returns the selected id. More...
int | GetPopupMenuSelectionFromUser (wxMenu &menu, int x, int y)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
bool | PopupMenu (wxMenu *menu, const wxPoint &pos=wxDefaultPosition)
| Pops up the given menu at the specified coordinates, relative to this window, and returns control when the user has dismissed the menu. More...
bool | PopupMenu (wxMenu *menu, int x, int y)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
virtual wxValidator * | GetValidator ()
| Validator functions. More...
virtual void | SetValidator (const wxValidator &validator)
| Deletes the current validator (if any) and sets the window validator, having called wxValidator::Clone to create a new validator of this type. More...
virtual bool | TransferDataFromWindow ()
| Transfers values from child controls to data areas specified by their validators. More...
virtual bool | TransferDataToWindow ()
| Transfers values to child controls from data areas specified by their validators. More...
virtual bool | Validate ()
| Validates the current values of the child controls using their validators. More...
wxWindowID | GetId () const
| Returns the identifier of the window. More...
virtual wxLayoutDirection | GetLayoutDirection () const
| Returns the layout direction for this window, Note that `wxLayout_Default` is returned if layout direction is not supported. More...
virtual wxCoord | AdjustForLayoutDirection (wxCoord x, wxCoord width, wxCoord widthTotal) const
| Mirror coordinates for RTL layout if this window uses it and if the mirroring is not done automatically like Win32. More...
virtual wxString | GetName () const
| Returns the window's name. More...
wxWindowVariant | GetWindowVariant () const
| Returns the value previously passed to SetWindowVariant(). More...
void | SetId (wxWindowID winid)
| Sets the identifier of the window. More...
virtual void | SetLayoutDirection (wxLayoutDirection dir)
| Sets the layout direction for this window. More...
virtual void | SetName (const wxString &name)
| Sets the window's name. More...
void | SetWindowVariant (wxWindowVariant variant)
| Chooses a different variant of the window display to use. More...
wxAcceleratorTable * | GetAcceleratorTable ()
| Gets the accelerator table for this window. More...
wxAccessible * | GetAccessible ()
| Returns the accessible object for this window, if any. More...
virtual void | SetAcceleratorTable (const wxAcceleratorTable &accel)
| Sets the accelerator table for this window. More...
void | SetAccessible (wxAccessible *accessible)
| Sets the accessible for this window. More...
virtual wxAccessible * | CreateAccessible ()
| Override to create a specific accessible object. More...
wxAccessible * | GetOrCreateAccessible ()
| Returns the accessible object, calling CreateAccessible if necessary. More...
bool | Close (bool force=false)
| This function simply generates a wxCloseEvent whose handler usually tries to close the window. More...
virtual bool | Destroy ()
| Destroys the window safely. More...
bool | IsBeingDeleted () const
| Returns true if this window is in process of being destroyed. More...
virtual wxDropTarget * | GetDropTarget () const
| Returns the associated drop target, which may be nullptr. More...
virtual void | SetDropTarget (wxDropTarget *target)
| Associates a drop target with this window. More...
virtual void | DragAcceptFiles (bool accept)
| Enables or disables eligibility for drop file events (OnDropFiles). More...
wxSizer * | GetContainingSizer () const
| Returns the sizer of which this window is a member, if any, otherwise nullptr. More...
wxSizer * | GetSizer () const
| Returns the sizer associated with the window by a previous call to SetSizer(), or nullptr. More...
void | SetSizer (wxSizer *sizer, bool deleteOld=true)
| Sets the window to have the given layout sizer. More...
void | SetSizerAndFit (wxSizer *sizer, bool deleteOld=true)
| Associate the sizer with the window and set the window size and minimal size accordingly. More...
wxLayoutConstraints * | GetConstraints () const
| Returns a pointer to the window's layout constraints, or nullptr if there are none. More...
void | SetConstraints (wxLayoutConstraints *constraints)
| Sets the window to have the given layout constraints. More...
virtual bool | Layout ()
| Lays out the children of this window using the associated sizer. More...
void | SetAutoLayout (bool autoLayout)
| Determines whether the Layout() function will be called automatically when the window is resized. More...
bool | GetAutoLayout () const
| Returns true if Layout() is called automatically when the window is resized. More...
void | CaptureMouse ()
| Directs all mouse input to this window. More...
wxCaret * | GetCaret () const
| Returns the caret() associated with the window. More...
wxCursor | GetCursor () const
| Return the cursor associated with this window. More...
wxCursorBundle | GetCursorBundle () const
| Returns the cursor bundle associated with this window. More...
virtual bool | HasCapture () const
| Returns true if this window has the current mouse capture. More...
void | ReleaseMouse ()
| Releases mouse input captured with CaptureMouse(). More...
void | SetCaret (wxCaret *caret)
| Sets the caret() associated with the window. More...
virtual bool | SetCursor (const wxCursor &cursor)
| Sets the window's cursor. More...
virtual bool | SetCursorBundle (const wxCursorBundle &cursors)
| Sets a collection of cursors to be used by the window. More...
virtual void | WarpPointer (int x, int y)
| Moves the pointer to the given position on the window. More...
virtual bool | EnableTouchEvents (int eventsMask)
| Request generation of touch events for this window. More...
wxHitTest | HitTest (wxCoord x, wxCoord y) const
| Return where the given point lies, exactly. More...
wxHitTest | HitTest (const wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
wxBorder | GetBorder (long flags) const
| Get the window border style from the given flags: this is different from simply doing flags & wxBORDER_MASK because it uses GetDefaultBorder() to translate wxBORDER_DEFAULT to something reasonable. More...
wxBorder | GetBorder () const
| Get border for the flags of this window. More...
virtual void | DoUpdateWindowUI (wxUpdateUIEvent &event)
| Does the window-specific updating after processing the update event. More...
virtual WXWidget | GetHandle () const
| Returns the platform-specific handle of the physical window. More...
WXHWND | GTKGetWin32Handle () const
| This function is used only with wxGTK when running on Windows, to receive a wxWindow's underlying HWND. More...
virtual bool | HasMultiplePages () const
| This method should be overridden to return true if this window has multiple pages. More...
virtual void | InheritAttributes ()
| This function is (or should be, in case of custom controls) called during window creation to intelligently set up the window visual attributes, that is the font and the foreground and background colours. More...
virtual void | InitDialog ()
| Sends an `wxEVT_INIT_DIALOG` event, whose handler usually transfers data to the dialog via validators. More...
virtual bool | IsDoubleBuffered () const
| Returns true if the window contents is double-buffered by the system, i.e. if any drawing done on the window is really done on a temporary backing surface and transferred to the screen all at once later. More...
void | SetDoubleBuffered (bool on)
| Turn on or off double buffering of the window if the system supports it. More...
virtual bool | IsRetained () const
| Returns true if the window is retained, false otherwise. More...
bool | IsThisEnabled () const
| Returns true if this window is intrinsically enabled, false otherwise, i.e. if Enable() Enable(false) had been called. More...
virtual bool | IsTopLevel () const
| Returns true if the given window is a top-level one. More...
virtual void | OnInternalIdle ()
| This virtual function is normally only used internally, but sometimes an application may need it to implement functionality that should not be disabled by an application defining an OnIdle handler in a derived class. More...
virtual bool | SendIdleEvents (wxIdleEvent &event)
| Send idle event to window and all subwindows. More...
virtual bool | RegisterHotKey (int hotkeyId, int modifiers, int virtualKeyCode)
| Registers a system wide hotkey. More...
virtual bool | UnregisterHotKey (int hotkeyId)
| Unregisters a system wide hotkey. More...
virtual void | UpdateWindowUI (long flags=wxUPDATE_UI_NONE)
| This function sends one or more wxUpdateUIEvent to the window. More...
virtual void | DoPrepareUpdateWindowUI (wxUpdateUIEvent &event) const
| When UpdateWindowUI() runs, it creates instances of wxUpdateUIEvent. More...
bool | BeginRepositioningChildren ()
| Prepare for changing positions of multiple child windows. More...
void | EndRepositioningChildren ()
| Fix child window positions after setting all of them at once. More...
void | CacheBestSize (const wxSize &size) const
| Sets the cached best size value. More...
virtual wxSize | ClientToWindowSize (const wxSize &size) const
| Converts client area size size to corresponding window size. More...
virtual wxSize | WindowToClientSize (const wxSize &size) const
| Converts window size size to corresponding client area size In other words, the returned value is what would GetClientSize() return if this window had given window size. More...
virtual void | Fit ()
| Sizes the window to fit its best size. More...
virtual void | FitInside ()
| Similar to Fit(), but sizes the interior (virtual) size of a window. More...
wxSize | FromDIP (const wxSize &sz) const
| Convert DPI-independent pixel values to the value in pixels appropriate for the current toolkit. More...
wxPoint | FromDIP (const wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
int | FromDIP (int d) const
| Convert DPI-independent distance in pixels to the value in pixels appropriate for the current toolkit. More...
wxSize | ToDIP (const wxSize &sz) const
| Convert pixel values of the current toolkit to DPI-independent pixel values. More...
wxPoint | ToDIP (const wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
int | ToDIP (int d) const
| Convert pixel values of the current toolkit to DPI-independent pixel values. More...
wxSize | FromPhys (const wxSize &sz) const
| Convert from physical pixels to logical pixels. More...
wxPoint | FromPhys (const wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
int | FromPhys (int d) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
wxSize | ToPhys (const wxSize &sz) const
| Convert from logical pixels to physical pixels. More...
wxPoint | ToPhys (const wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
int | ToPhys (int d) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
wxSize | GetBestSize () const
| This functions returns the best acceptable minimal size for the window. More...
int | GetBestHeight (int width) const
| Returns the best height needed by this window if it had the given width. More...
int | GetBestWidth (int height) const
| Returns the best width needed by this window if it had the given height. More...
void | GetClientSize (int *width, int *height) const
| Returns the size of the window 'client area' in pixels. More...
wxSize | GetClientSize () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
virtual wxSize | GetEffectiveMinSize () const
| Merges the window's best size into the min size and returns the result. More...
virtual wxSize | GetMaxClientSize () const
| Returns the maximum size of window's client area. More...
virtual wxSize | GetMaxSize () const
| Returns the maximum size of the window. More...
virtual wxSize | GetMinClientSize () const
| Returns the minimum size of window's client area, an indication to the sizer layout mechanism that this is the minimum required size of its client area. More...
virtual wxSize | GetMinSize () const
| Returns the minimum size of the window, an indication to the sizer layout mechanism that this is the minimum required size. More...
int | GetMinWidth () const
| Returns the horizontal component of window minimal size. More...
int | GetMinHeight () const
| Returns the vertical component of window minimal size. More...
int | GetMaxWidth () const
| Returns the horizontal component of window maximal size. More...
int | GetMaxHeight () const
| Returns the vertical component of window maximal size. More...
void | GetSize (int *width, int *height) const
| Returns the size of the entire window in pixels, including title bar, border, scrollbars, etc. More...
wxSize | GetSize () const
| See the GetSize(int*,int*) overload for more info. More...
wxSize | GetVirtualSize () const
| This gets the virtual size of the window in pixels. More...
void | GetVirtualSize (int *width, int *height) const
| Like the other GetVirtualSize() overload but uses pointers instead. More...
virtual wxSize | GetBestVirtualSize () const
| Return the largest of ClientSize and BestSize (as determined by a sizer, interior children, or other means) More...
double | GetContentScaleFactor () const
| Returns the factor mapping logical pixels of this window to physical pixels. More...
double | GetDPIScaleFactor () const
| Returns the ratio of the DPI used by this window to the standard DPI. More...
virtual wxSize | GetWindowBorderSize () const
| Returns the size of the left/right and top/bottom borders of this window in x and y components of the result respectively. More...
virtual bool | InformFirstDirection (int direction, int size, int availableOtherDir)
| wxSizer and friends use this to give a chance to a component to recalc its min size once one of the final size components is known. More...
void | InvalidateBestSize ()
| Resets the cached best size value so it will be recalculated the next time it is needed. More...
void | PostSizeEvent ()
| Posts a size event to the window. More...
void | PostSizeEventToParent ()
| Posts a size event to the parent of this window. More...
virtual void | SendSizeEvent (int flags=0)
| This function sends a dummy size event to the window allowing it to re-layout its children positions. More...
void | SendSizeEventToParent (int flags=0)
| Safe wrapper for GetParent()->SendSizeEvent(). More...
void | SetClientSize (int width, int height)
| This sets the size of the window client area in pixels. More...
void | SetClientSize (const wxSize &size)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
void | SetClientSize (const wxRect &rect)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
void | SetContainingSizer (wxSizer *sizer)
| Used by wxSizer internally to notify the window about being managed by the given sizer. More...
void | SetInitialSize (const wxSize &size=wxDefaultSize)
| A smart SetSize that will fill in default size components with the window's best size values. More...
virtual void | SetMaxClientSize (const wxSize &size)
| Sets the maximum client size of the window, to indicate to the sizer layout mechanism that this is the maximum possible size of its client area. More...
virtual void | SetMaxSize (const wxSize &size)
| Sets the maximum size of the window, to indicate to the sizer layout mechanism that this is the maximum possible size. More...
virtual void | SetMinClientSize (const wxSize &size)
| Sets the minimum client size of the window, to indicate to the sizer layout mechanism that this is the minimum required size of window's client area. More...
virtual void | SetMinSize (const wxSize &size)
| Sets the minimum size of the window, to indicate to the sizer layout mechanism that this is the minimum required size. More...
void | SetSize (int x, int y, int width, int height, int sizeFlags=wxSIZE_AUTO)
| Sets the size of the window in pixels. More...
void | SetSize (const wxRect &rect)
| Sets the size of the window in pixels. More...
void | SetSize (const wxSize &size)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
void | SetSize (int width, int height)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
virtual void | SetSizeHints (const wxSize &minSize, const wxSize &maxSize=wxDefaultSize, const wxSize &incSize=wxDefaultSize)
| Use of this function for windows which are not toplevel windows (such as wxDialog or wxFrame) is discouraged. More...
virtual void | SetSizeHints (int minW, int minH, int maxW=-1, int maxH=-1, int incW=-1, int incH=-1)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
void | SetVirtualSize (int width, int height)
| Sets the virtual size of the window in pixels. More...
void | SetVirtualSize (const wxSize &size)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
Public Member Functions inherited from wxEvtHandler
| wxEvtHandler ()
| Constructor. More...
virtual | ~wxEvtHandler ()
| Destructor. More...
template<typename T , typename T1 , ... >
void | CallAfter (void(T::*method)(T1,...), T1 x1,...)
| Asynchronously call the given method. More...
template<typename T >
void | CallAfter (const T &functor)
| Asynchronously call the given functor. More...
bool | ProcessEventLocally (wxEvent &event)
| Try to process the event in this handler and all those chained to it. More...
bool | SafelyProcessEvent (wxEvent &event)
| Processes an event by calling ProcessEvent() and handles any exceptions that occur in the process. More...
void | ProcessPendingEvents ()
| Processes the pending events previously queued using QueueEvent() or AddPendingEvent(); you must call this function only if you are sure there are pending events for this handler, otherwise a `wxCHECK` will fail. More...
void | DeletePendingEvents ()
| Deletes all events queued on this event handler using QueueEvent() or AddPendingEvent(). More...
void | Connect (int id, int lastId, wxEventType eventType, wxObjectEventFunction function, wxObject *userData=nullptr, wxEvtHandler *eventSink=nullptr)
| Connects the given function dynamically with the event handler, id and event type. More...
void | Connect (int id, wxEventType eventType, wxObjectEventFunction function, wxObject *userData=nullptr, wxEvtHandler *eventSink=nullptr)
| See the Connect(int, int, wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info. More...
void | Connect (wxEventType eventType, wxObjectEventFunction function, wxObject *userData=nullptr, wxEvtHandler *eventSink=nullptr)
| See the Connect(int, int, wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info. More...
bool | Disconnect (wxEventType eventType, wxObjectEventFunction function, wxObject *userData=nullptr, wxEvtHandler *eventSink=nullptr)
| Disconnects the given function dynamically from the event handler, using the specified parameters as search criteria and returning true if a matching function has been found and removed. More...
bool | Disconnect (int id=wxID_ANY, wxEventType eventType=wxEVT_NULL, wxObjectEventFunction function=nullptr, wxObject *userData=nullptr, wxEvtHandler *eventSink=nullptr)
| See the Disconnect(wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info. More...
bool | Disconnect (int id, int lastId, wxEventType eventType, wxObjectEventFunction function=nullptr, wxObject *userData=nullptr, wxEvtHandler *eventSink=nullptr)
| See the Disconnect(wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info. More...
template<typename EventTag , typename Functor >
void | Bind (const EventTag &eventType, Functor functor, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=nullptr)
| Binds the given function, functor or method dynamically with the event. More...
template<typename EventTag , typename Class , typename EventArg , typename EventHandler >
void | Bind (const EventTag &eventType, void(Class::*method)(EventArg &), EventHandler *handler, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=nullptr)
| See the Bind<>(const EventTag&, Functor, int, int, wxObject*) overload for more info. More...
template<typename EventTag , typename Functor >
bool | Unbind (const EventTag &eventType, Functor functor, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=nullptr)
| Unbinds the given function, functor or method dynamically from the event handler, using the specified parameters as search criteria and returning true if a matching function has been found and removed. More...
template<typename EventTag , typename Class , typename EventArg , typename EventHandler >
bool | Unbind (const EventTag &eventType, void(Class::*method)(EventArg &), EventHandler *handler, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=nullptr)
| See the Unbind<>(const EventTag&, Functor, int, int, wxObject*) overload for more info. More...
void * | GetClientData () const
| Returns user-supplied client data. More...
wxClientData * | GetClientObject () const
| Returns a pointer to the user-supplied client data object. More...
void | SetClientData (void *data)
| Sets user-supplied client data. More...
void | SetClientObject (wxClientData *data)
| Set the client data object. More...
bool | GetEvtHandlerEnabled () const
| Returns true if the event handler is enabled, false otherwise. More...
wxEvtHandler * | GetNextHandler () const
| Returns the pointer to the next handler in the chain. More...
wxEvtHandler * | GetPreviousHandler () const
| Returns the pointer to the previous handler in the chain. More...
void | SetEvtHandlerEnabled (bool enabled)
| Enables or disables the event handler. More...
void | Unlink ()
| Unlinks this event handler from the chain it's part of (if any); then links the "previous" event handler to the "next" one (so that the chain won't be interrupted). More...
bool | IsUnlinked () const
| Returns true if the next and the previous handler pointers of this event handler instance are nullptr. More...
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to nullptr the internal reference data. More...
| wxObject (const wxObject &other)
| Copy ctor. More...
virtual | ~wxObject ()
| Destructor. More...
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar). More...
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object. More...
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class. More...
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj. More...
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone. More...
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer. More...
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data. More...
void | UnShare ()
| This is the same of AllocExclusive() but this method is public. More...
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...
void * | operator new (size_t size, const wxString &filename=nullptr, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...

## Static Public Member Functions
static wxWebView * | New (const wxString &backend=wxWebViewBackendDefault)
| Factory function to create a new wxWebView with two-step creation, wxWebView::Create should be called on the returned object. More...
static wxWebView * | New (const wxWebViewConfiguration &config)
| Factory function to create a new wxWebView with two-step creation, wxWebView::Create should be called on the returned object. More...
static wxWebView * | New (wxWindow *parent, wxWindowID id, const wxString &url=wxWebViewDefaultURLStr, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, const wxString &backend=wxWebViewBackendDefault, long style=0, const wxString &name=wxWebViewNameStr)
| Factory function to create a new wxWebView using a wxWebViewFactory. More...
static void | RegisterFactory (const wxString &backend, wxSharedPtr< wxWebViewFactory > factory)
| Allows the registering of new backend for wxWebView. More...
static bool | IsBackendAvailable (const wxString &backend)
| Allows to check if a specific backend is currently available. More...
static wxVersionInfo | GetBackendVersionInfo (const wxString &backend=wxWebViewBackendDefault, wxVersionContext context=wxVersionContext::RunTime)
| Retrieve the version information about the backend implementation. More...
static wxWebViewConfiguration | NewConfiguration (const wxString &backend=wxWebViewBackendDefault)
| Create a new wxWebViewConfiguration object. More...
Static Public Member Functions inherited from wxControl
static wxString | GetLabelText (const wxString &label)
| Returns the given label string without mnemonics ("&" characters). More...
static wxString | RemoveMnemonics (const wxString &str)
| Returns the given str string without mnemonics ("&" characters). More...
static wxString | EscapeMnemonics (const wxString &text)
| Escapes the special mnemonics characters ("&") in the given string. More...
static wxString | Ellipsize (const wxString &label, const wxReadOnlyDC &dc, wxEllipsizeMode mode, int maxWidth, int flags=wxELLIPSIZE_FLAGS_DEFAULT)
| Replaces parts of the label string with ellipsis, if needed, so that it fits into maxWidth pixels if possible. More...
Static Public Member Functions inherited from wxWindow
static wxVisualAttributes | GetClassDefaultAttributes (wxWindowVariant variant=wxWINDOW_VARIANT_NORMAL)
| Returns the default font and colours which are used by the control. More...
static wxWindow * | FindFocus ()
| Finds the window or control which currently has the keyboard focus. More...
static wxWindow * | FindWindowById (long id, const wxWindow *parent=0)
| Find the first window with the given id. More...
static wxWindow * | FindWindowByLabel (const wxString &label, const wxWindow *parent=0)
| Find a window by its label. More...
static wxWindow * | FindWindowByName (const wxString &name, const wxWindow *parent=0)
| Find a window by its name (as given in a window constructor or Create() function call). More...
static wxWindow * | GetCapture ()
| Returns the currently captured window. More...
static wxWindowID | NewControlId (int count=1)
| Create a new ID or range of IDs that are not currently in use. More...
static void | UnreserveControlId (wxWindowID id, int count=1)
| Unreserve an ID or range of IDs that was reserved by NewControlId(). More...
static wxSize | FromDIP (const wxSize &sz, const wxWindow *w)
| Non window-specific DPI-independent pixels conversion functions. More...
static wxPoint | FromDIP (const wxPoint &pt, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
static int | FromDIP (int d, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
static wxSize | ToDIP (const wxSize &sz, const wxWindow *w)
| Non window-specific pixel to DPI-independent pixels conversion functions. More...
static wxPoint | ToDIP (const wxPoint &pt, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
static int | ToDIP (int d, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
static wxSize | FromPhys (const wxSize &sz, const wxWindow *w)
| Convert from physical pixels to logical pixels for any window. More...
static wxPoint | FromPhys (const wxPoint &pt, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
static int | FromPhys (int d, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
static wxSize | ToPhys (const wxSize &sz, const wxWindow *w)
| Convert from logical pixels to physical pixels for any window. More...
static wxPoint | ToPhys (const wxPoint &pt, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
static int | ToPhys (int d, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
Static Public Member Functions inherited from wxEvtHandler
static void | AddFilter (wxEventFilter *filter)
| Add an event filter whose FilterEvent() method will be called for each and every event processed by wxWidgets. More...
static void | RemoveFilter (wxEventFilter *filter)
| Remove a filter previously installed with AddFilter(). More...

## Additional Inherited Members
Protected Member Functions inherited from wxWindow
virtual void | DoCentre (int direction)
| Centres the window. More...
virtual wxSize | DoGetBestSize () const
| Implementation of GetBestSize() that can be overridden. More...
virtual wxSize | DoGetBestClientSize () const
| Override this method to return the best size for a custom control. More...
virtual int | DoGetBestClientHeight (int width) const
| Override this method to implement height-for-width best size calculation. More...
virtual int | DoGetBestClientWidth (int height) const
| Override this method to implement width-for-height best size calculation. More...
virtual void | SetInitialBestSize (const wxSize &size)
| Sets the initial window size if none is given (i.e. at least one of the components of the size passed to ctor/Create() is wxDefaultCoord). More...
void | SendDestroyEvent ()
| Generate wxWindowDestroyEvent for this window. More...
virtual bool | ProcessEvent (wxEvent &event)
| This function is public in wxEvtHandler but protected in wxWindow because for wxWindows you should always call ProcessEvent() on the pointer returned by GetEventHandler() and not on the wxWindow object itself. More...
bool | SafelyProcessEvent (wxEvent &event)
| See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow. More...
virtual void | QueueEvent (wxEvent *event)
| See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow. More...
virtual void | AddPendingEvent (const wxEvent &event)
| See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow. More...
void | ProcessPendingEvents ()
| See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow. More...
bool | ProcessThreadEvent (const wxEvent &event)
| See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow. More...
Protected Member Functions inherited from wxEvtHandler
virtual bool | TryBefore (wxEvent &event)
| Method called by ProcessEvent() before examining this object event tables. More...
virtual bool | TryAfter (wxEvent &event)
| Method called by ProcessEvent() as last resort. More...
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object. More...
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it. More...
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data. More...
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data. More...

## Member Function Documentation

## ◆ AddScriptMessageHandler()

virtual bool wxWebView::AddScriptMessageHandler | ( | const wxString & | name | ) |
| virtual

Add a script message handler with the given name.

To use the script message handler from javascript use `window.<name>.postMessage(<messageBody>)` where `<name>` corresponds the value of the name parameter. The `<messageBody>` will be available to the application via a `wxEVT_WEBVIEW_SCRIPT_MESSAGE_RECEIVED` event.

Sample C++ code receiving a script message:

// Install message handler with the name wx_msg
m_webView->AddScriptMessageHandler("wx_msg");
// Bind handler
m_webView->Bind(wxEVT_WEBVIEW_SCRIPT_MESSAGE_RECEIVED, [](wxWebViewEvent& evt) {
wxLogMessage("Script message received; value = %s, handler = %s", evt.GetString(), evt.GetMessageHandler());
});
wxCommandEvent::GetString
wxString GetString() const
Returns item string for a listbox or choice selection event.
wxWebViewEvent
A navigation event holds information about events associated with wxWebView objects.
Definition: webview.h:2055
wxWebViewEvent::GetMessageHandler
const wxString & GetMessageHandler() const
Get the name of the script handler.
wxLogMessage
void wxLogMessage(const char *formatString,...)
For all normal, informational messages.
wxEVT_WEBVIEW_SCRIPT_MESSAGE_RECEIVED
wxEventType wxEVT_WEBVIEW_SCRIPT_MESSAGE_RECEIVED
Definition: webview.h:2132

Sample JavaScript sending a script message:

// Send sample message body
window.wx_msg.postMessage('This is a message body');

Parameters

  name | Name of the message handler that can be used from JavaScript

Returns
  true if the handler could be added, false if it could not be added.

See also
  RemoveScriptMessageHandler()

Note
  The Edge backend only supports a single message handler and the Chromium and IE backends do not support script message handlers.

Since
  3.1.5

## ◆ AddUserScript()

virtual bool wxWebView::AddUserScript | ( | const wxString & | javascript,
|  | wxWebViewUserScriptInjectionTime | injectionTime = `wxWEBVIEW_INJECT_AT_DOCUMENT_START`
| ) |  |
| virtual

Injects the specified script into the webpage's content.

Parameters

  javascript | The JavaScript code to add.
  injectionTime | Specifies when the script will be executed.

Returns
  true if the script was added successfully.

Note
  Please note that this is unsupported by the IE backend and the Edge backend does only support wxWEBVIEW_INJECT_AT_DOCUMENT_START.

See also
  RemoveAllUserScripts()

Since
  3.1.5

## ◆ AreBrowserAcceleratorKeysEnabled()

virtual bool wxWebView::AreBrowserAcceleratorKeysEnabled | ( |  | ) | const
| virtual

Returns true if browser accelerator keys are enabled.

Since
  3.3.0

## ◆ CanCopy()

virtual bool wxWebView::CanCopy | ( |  | ) | const
| virtual

Returns true if the current selection can be copied.

## ◆ CanCut()

virtual bool wxWebView::CanCut | ( |  | ) | const
| virtual

Returns true if the current selection can be cut.

## ◆ CanGoBack()

virtual bool wxWebView::CanGoBack | ( |  | ) | const
| pure virtual

Returns true if it is possible to navigate backward in the history of visited pages.

## ◆ CanGoForward()

virtual bool wxWebView::CanGoForward | ( |  | ) | const
| pure virtual

Returns true if it is possible to navigate forward in the history of visited pages.

## ◆ CanPaste()

virtual bool wxWebView::CanPaste | ( |  | ) | const
| virtual

Returns true if data can be pasted.

## ◆ CanRedo()

virtual bool wxWebView::CanRedo | ( |  | ) | const
| pure virtual

Returns true if there is an action to redo.

## ◆ CanSetZoomType()

virtual bool wxWebView::CanSetZoomType | ( | wxWebViewZoomType | type | ) | const
| pure virtual

Retrieve whether a zoom type is supported.

Parameters

  type | The zoom type to test.

Returns
  true if this type of zoom is supported by this backend (and thus can be set through SetZoomType()).

## ◆ CanUndo()

virtual bool wxWebView::CanUndo | ( |  | ) | const
| pure virtual

Returns true if there is an action to undo.

## ◆ ClearBrowsingData()

virtual bool wxWebView::ClearBrowsingData | ( | int | types = `wxWEBVIEW_BROWSING_DATA_ALL`,
|  | wxDateTime | since = `{}`
| ) |  |
| virtual

Clears the browsing data of the web view.

This function clears the browsing data of the web view, such as cookies, cache, history, etc. The exact data that is cleared depends on the backend used.

This operation is asynchronous and may take some time to complete. When finished `wxEVT_WEBVIEW_BROWSING_DATA_CLEARED` event is generated.

Parameters

  types | The types of browsing data to clear. By default, it clears all types of browsing data.
  since | The time since when the browsing data should be cleared. By default, it clears all browsing data.

Returns
  false if backend doesn't support clearing browsing data or an error occurred. Otherwise, true is returned and the browsing data will be cleared asynchronously and the application will receive a `wxEVT_WEBVIEW_BROWSING_DATA_CLEARED` event when it is done (or if doing it fails later).

Since
  3.3.0

Note
  This is only implemented in the Edge, WebKit2GTK+ and macOS backends.

See also
  wxWebViewBrowsingDataTypes

## ◆ ClearHistory()

virtual void wxWebView::ClearHistory | ( |  | ) |
| pure virtual

Clear the history, this will also remove the visible page.

Note
  This is not implemented on the WebKit2GTK+ backend and macOS.

## ◆ ClearSelection()

virtual void wxWebView::ClearSelection | ( |  | ) |
| virtual

Clears the current selection.

## ◆ Copy()

virtual void wxWebView::Copy | ( |  | ) |
| virtual

Copies the current selection.

## ◆ Create()

virtual bool wxWebView::Create | ( | wxWindow * | parent,
|  | wxWindowID | id,
|  | const wxString & | url = `wxWebViewDefaultURLStr`,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `0`,
|  | const wxString & | name = `wxWebViewNameStr`
| ) |  |
| pure virtual

Creation function for two-step creation.

Please note that the object creation may be asynchronous when using some backends (e.g., wxWebViewEdge or wxWebViewChromium) and the object is not really created until `wxEVT_WEBVIEW_CREATED` event is received, so any non-trivial calls to its member functions should be delayed until then.

Implemented in wxWebViewChromium.

## ◆ Cut()

virtual void wxWebView::Cut | ( |  | ) |
| virtual

Cuts the current selection.

## ◆ DeleteSelection()

virtual void wxWebView::DeleteSelection | ( |  | ) |
| virtual

Deletes the current selection.

Note that for `wxWEBVIEW_BACKEND_WEBKIT` the selection must be editable, either through SetEditable or the correct HTML attribute.

## ◆ EnableAccessToDevTools()

virtual void wxWebView::EnableAccessToDevTools | ( | bool | enable = `true` | ) |
| virtual

Enable or disable access to dev tools for the user.

Dev tools are disabled by default.

Note
  This is not implemented for the IE backend.

Since
  3.1.4

See also
  ShowDevTools()

## ◆ EnableBrowserAcceleratorKeys()

virtual void wxWebView::EnableBrowserAcceleratorKeys | ( | bool | enable = `true` | ) |
| virtual

Enable or disable if browser accelerator keys are enabled.

Browser accelerator keys are enabled by default.

The webview might implement various accelerator keys. This includes allowing accelerator key access to features such as printing and navigation. In many cases this might not be desired and the default keys can be disabled with this setting.

Note
  This is only implemented for the Edge backend.

Since
  3.3.0

## ◆ EnableContextMenu()

virtual void wxWebView::EnableContextMenu | ( | bool | enable = `true` | ) |
| virtual

Enable or disable the right click context menu.

By default the standard context menu is enabled, this method can be used to disable it or re-enable it later.

Since
  2.9.5

## ◆ EnableHistory()

virtual void wxWebView::EnableHistory | ( | bool | enable = `true` | ) |
| pure virtual

Enable or disable the history.

This will also clear the history.

Note
  This is not implemented on the WebKit2GTK+ backend and macOS.

## ◆ Find()

virtual long wxWebView::Find | ( | const wxString & | text,
|  | wxWebViewFindFlags | flags = `wxWEBVIEW_FIND_DEFAULT`
| ) |  |
| virtual

Finds a phrase on the current page and if found, the control will scroll the phrase into view and select it.

Parameters

  text | The phrase to search for.
  flags | The flags for the search.

Returns
  If search phrase was not found in combination with the flags then `wxNOT_FOUND` is returned. If called for the first time with search phrase then the total number of results will be returned. Then for every time its called with the same search phrase it will return the number of the current match.

Note
  This function will restart the search if the flags `wxWEBVIEW_FIND_ENTIRE_WORD` or `wxWEBVIEW_FIND_MATCH_CASE` are changed, since this will require a new search. To reset the search, for example resetting the highlights call the function with an empty search phrase.

Since
  2.9.5

## ◆ GetBackendVersionInfo()

static wxVersionInfo wxWebView::GetBackendVersionInfo | ( | const wxString & | backend = `wxWebViewBackendDefault`,
|  | wxVersionContext | context = `wxVersionContext::RunTime`
| ) |  |
| static

Retrieve the version information about the backend implementation.

Parameters

  backend | The name of the backend to retrieve the version information for, can be left unspecified to use the default backend.
  context | The context in which the version information is requested, by default it is the run-time version. Currently only GTK WebKit and CEF backends support returning compile-time version information, all the other backends return an empty wxVersionInfo object in this case.

Since
  3.1.5 (context parameter was added in 3.3.0)

## ◆ GetBackwardHistory()

virtual wxVector<wxSharedPtr<wxWebViewHistoryItem> > wxWebView::GetBackwardHistory | ( |  | ) |
| pure virtual

Returns a list of items in the back history.

The first item in the vector is the first page that was loaded by the control.

## ◆ GetCurrentTitle()

virtual wxString wxWebView::GetCurrentTitle | ( |  | ) | const
| pure virtual

Get the title of the current web page, or its URL/path if title is not available.

## ◆ GetCurrentURL()

virtual wxString wxWebView::GetCurrentURL | ( |  | ) | const
| pure virtual

Get the URL of the currently displayed document.

## ◆ GetForwardHistory()

virtual wxVector<wxSharedPtr<wxWebViewHistoryItem> > wxWebView::GetForwardHistory | ( |  | ) |
| pure virtual

Returns a list of items in the forward history.

The first item in the vector is the next item in the history with respect to the currently loaded page.

## ◆ GetNativeBackend()

virtual void* wxWebView::GetNativeBackend | ( |  | ) | const
| pure virtual

Return the pointer to the native backend used by this control.

This method can be used to retrieve the pointer to the native web engine used by this control. The return value needs to be down-casted to the appropriate type depending on the backend:

Backend | Platform | Type
--- | --- | ---
wxWEBVIEW_BACKEND_IE | MSW | IWebBrowser2
wxWEBVIEW_BACKEND_EDGE | MSW | ICoreWebView2_2
wxWEBVIEW_WEBKIT2 | GTK3 | WebKitWebView
wxWEBVIEW_WEBKIT | macOS | WKWebView
wxWEBVIEW_CHROMIUM | MSW, macOS, GTK | CefBrowser

For example, you could set the WebKit options using this method:

#include <webkit/webkit.h>
#ifdef __WXGTK__
WebKitWebView*
wv = static_cast<WebKitWebView*>(m_window->GetNativeBackend());
WebKitWebSettings* settings = webkit_web_view_get_settings(wv);
g_object_set(G_OBJECT(settings),
"enable-frame-flattening", TRUE,
nullptr);
#endif

See also
  GetBackendVersionInfo()

Since
  2.9.5

## ◆ GetPageSource()

virtual wxString wxWebView::GetPageSource | ( |  | ) | const
| virtual

Get the HTML source code of the currently displayed document.

Returns
  The HTML source code, or an empty string if no page is currently shown.

## ◆ GetPageText()

virtual wxString wxWebView::GetPageText | ( |  | ) | const
| virtual

Get the text of the current page.

## ◆ GetSelectedSource()

virtual wxString wxWebView::GetSelectedSource | ( |  | ) | const
| virtual

Returns the currently selected source, if any.

## ◆ GetSelectedText()

virtual wxString wxWebView::GetSelectedText | ( |  | ) | const
| virtual

Returns the currently selected text, if any.

## ◆ GetUserAgent()

virtual wxString wxWebView::GetUserAgent | ( |  | ) | const
| virtual

Returns the current user agent string for the web view.

Since
  3.1.5

## ◆ GetZoom()

virtual wxWebViewZoom wxWebView::GetZoom | ( |  | ) | const
| virtual

Get the zoom level of the page.

See GetZoomFactor() to get more precise zoom scale value other than as provided by `wxWebViewZoom`.

Returns
  The current level of zoom.

## ◆ GetZoomFactor()

virtual float wxWebView::GetZoomFactor | ( |  | ) | const
| pure virtual

Get the zoom factor of the page.

Returns
  The current factor of zoom.

Since
  3.1.4

## ◆ GetZoomType()

virtual wxWebViewZoomType wxWebView::GetZoomType | ( |  | ) | const
| pure virtual

Get how the zoom factor is currently interpreted.

Returns
  How the zoom factor is currently interpreted by the backend.

## ◆ GoBack()

virtual void wxWebView::GoBack | ( |  | ) |
| pure virtual

Navigate back in the history of visited pages.

Only valid if CanGoBack() returns true.

## ◆ GoForward()

virtual void wxWebView::GoForward | ( |  | ) |
| pure virtual

Navigate forward in the history of visited pages.

Only valid if CanGoForward() returns true.

## ◆ HasSelection()

virtual bool wxWebView::HasSelection | ( |  | ) | const
| virtual

Returns true if there is a current selection.

## ◆ IsAccessToDevToolsEnabled()

virtual bool wxWebView::IsAccessToDevToolsEnabled | ( |  | ) | const
| virtual

Returns true if dev tools are available to the user.

Since
  3.1.4

## ◆ IsBackendAvailable()

static bool wxWebView::IsBackendAvailable | ( | const wxString & | backend | ) |
| static

Allows to check if a specific backend is currently available.

For example, to check for Edge backend availability:

if ( wxWebView::IsBackendAvailable(wxWebViewBackendEdge) )
{
... enable some extra functionality not available with the IE backend ...
}
wxWebView::IsBackendAvailable
static bool IsBackendAvailable(const wxString &backend)
Allows to check if a specific backend is currently available.

Since
  3.1.4

## ◆ IsBusy()

virtual bool wxWebView::IsBusy | ( |  | ) | const
| pure virtual

Returns whether the web control is currently busy (e.g. loading a page).

## ◆ IsContextMenuEnabled()

virtual bool wxWebView::IsContextMenuEnabled | ( |  | ) | const
| virtual

Returns true if a context menu will be shown on right click.

Since
  2.9.5

## ◆ IsEditable()

virtual bool wxWebView::IsEditable | ( |  | ) | const
| pure virtual

Returns whether the web control is currently editable.

## ◆ LoadHistoryItem()

virtual void wxWebView::LoadHistoryItem | ( | wxSharedPtr< wxWebViewHistoryItem > | item | ) |
| pure virtual

Loads a history item.

## ◆ LoadURL()

virtual void wxWebView::LoadURL | ( | const wxString & | url | ) |
| pure virtual

Load a web page from a URL.

Parameters

  url | The URL of the page to be loaded.

Note
  Web engines generally report errors asynchronously, so if you wish to know whether loading the URL was successful, register to receive navigation error events.

## ◆ New() [1/3]

static wxWebView* wxWebView::New | ( | const wxString & | backend = `wxWebViewBackendDefault` | ) |
| static

Factory function to create a new wxWebView with two-step creation, wxWebView::Create should be called on the returned object.

Parameters

  backend | The backend to use.

Returns
  The created wxWebView.

Since
  2.9.5

## ◆ New() [2/3]

static wxWebView* wxWebView::New | ( | const wxWebViewConfiguration & | config | ) |
| static

Factory function to create a new wxWebView with two-step creation, wxWebView::Create should be called on the returned object.

Parameters

  config | a configuration object create with NewConfiguration().

Returns
  The created wxWebView

Since
  3.3.0

## ◆ New() [3/3]

static wxWebView* wxWebView::New | ( | wxWindow * | parent,
|  | wxWindowID | id,
|  | const wxString & | url = `wxWebViewDefaultURLStr`,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | const wxString & | backend = `wxWebViewBackendDefault`,
|  | long | style = `0`,
|  | const wxString & | name = `wxWebViewNameStr`
| ) |  |
| static

Factory function to create a new wxWebView using a wxWebViewFactory.

Note that the returned object may not be immediately usable yet, see Create() and wxEVT_WEBVIEW_CREATED.

Parameters

  parent | Parent window for the control
  id | ID of this control
  url | Initial URL to load
  pos | Position of the control
  size | Size of the control
  backend | The backend web engine to use. `wxWebViewBackendDefault` and other backend names constants in format `wxWebViewBackend<Name>` (e.g., `wxWebViewBackendWebKit`) are predefined where appropriate. See Backend descriptions.
  style | Window style. For generic window styles, please see wxWindow.
  name | Window name.

Returns
  The created wxWebView, or nullptr if the requested backend is not available

Since
  2.9.5

## ◆ NewConfiguration()

static wxWebViewConfiguration wxWebView::NewConfiguration | ( | const wxString & | backend = `wxWebViewBackendDefault` | ) |
| static

Create a new wxWebViewConfiguration object.

Since
  3.3.0

## ◆ Paste()

virtual void wxWebView::Paste | ( |  | ) |
| virtual

Pastes the current data.

## ◆ Print()

virtual void wxWebView::Print | ( |  | ) |
| pure virtual

Opens a print dialog so that the user may print the currently displayed page.

## ◆ Redo()

virtual void wxWebView::Redo | ( |  | ) |
| pure virtual

Redos the last action.

## ◆ RegisterFactory()

static void wxWebView::RegisterFactory | ( | const wxString & | backend,
|  | wxSharedPtr< wxWebViewFactory > | factory
| ) |  |
| static

Allows the registering of new backend for wxWebView.

backend can be used as an argument to New().

Parameters

  backend | The name for the new backend to be registered under
  factory | A shared pointer to the factory which creates the appropriate backend.

Since
  2.9.5

## ◆ RegisterHandler()

virtual void wxWebView::RegisterHandler | ( | wxSharedPtr< wxWebViewHandler > | handler | ) |
| pure virtual

Registers a custom scheme handler.

Parameters

  handler | A shared pointer to a wxWebHandler.

Note
  On macOS in order to use handlers two-step creation has to be used and RegisterHandler() has to be called before Create(). With the other backends it has to be called after Create().
  The Edge backend does not support custom schemes, but the handler is available as a virtual host under `https://scheme.wxsite`. To customize this virtual host call wxWebViewHandler::SetVirtualHost() before registering the handler.

## ◆ Reload()

virtual void wxWebView::Reload | ( | wxWebViewReloadFlags | flags = `wxWEBVIEW_RELOAD_DEFAULT` | ) |
| pure virtual

Reload the currently displayed URL.

Parameters

  flags | A bit array that may optionally contain reload options.

Note
  The flags are ignored by the Edge backend.

## ◆ RemoveAllUserScripts()

virtual void wxWebView::RemoveAllUserScripts | ( |  | ) |
| virtual

Removes all user scripts from the web view.

See also
  AddUserScript()

Since
  3.1.5

## ◆ RemoveScriptMessageHandler()

virtual bool wxWebView::RemoveScriptMessageHandler | ( | const wxString & | name | ) |
| virtual

Remove a script message handler with the given name that was previously added via AddScriptMessageHandler().

Returns
  true if the handler could be removed, false if it could not be removed.

See also
  AddScriptMessageHandler()

Since
  3.1.5

## ◆ RunScript()

virtual bool wxWebView::RunScript | ( | const wxString & | javascript,
|  | wxString * | output = `nullptr`
| ) |  | const
| pure virtual

Runs the given JavaScript code.

Note
  Because of various potential issues it's recommended to use RunScriptAsync() instead of this method. This is especially true if you plan to run code from a webview event and will also prevent unintended side effects on the UI outside of the webview.

JavaScript code is executed inside the browser control and has full access to DOM and other browser-provided functionality. For example, this code

webview->RunScript("document.write('Hello from wxWidgets!')");

will replace the current page contents with the provided string.

If output is non-null, it is filled with the result of executing this code on success, e.g. a JavaScript value such as a string, a number (integer or floating point), a boolean or JSON representation for non-primitive types such as arrays and objects. For example:

wxString result;
if ( webview->RunScript
(
"document.getElementById('some_id').innerHTML",
&result
) )
{
... result contains the contents of the given element ...
}
//else: the element with this ID probably doesn't exist.
wxString
String class for passing textual data to or receiving it from wxWidgets.
Definition: string.h:372

This function has a few platform-specific limitations:

- When using WebKit v1 in wxGTK2, retrieving the result of JavaScript execution is unsupported and this function will always return false if output is non-null to indicate this. This functionality is fully supported when using WebKit v2 or later in wxGTK3.
- When using WebKit under macOS, code execution is limited to at most 10MiB of memory and 10 seconds of execution time.
- When using Chromium backend, retrieving the result of JavaScript execution is unsupported and this function will always return false if output is non-null to indicate this.
- When using IE backend under MSW, scripts can only be executed when the current page is fully loaded (i.e. `wxEVT_WEBVIEW_LOADED` event was received). A script tag inside the page HTML is required in order to run JavaScript.

Also notice that with the IE backend converting JavaScript objects to JSON is not supported in the default emulation mode, it implements its own object-to-JSON conversion as a fallback for this case, however it is not as full-featured, well-tested or performing as the implementation of this functionality in the browser control itself, so it is recommended to use MSWSetEmulationLevel() to change emulation level to a more modern one in which JSON conversion is done by the control itself.

Parameters

  javascript | JavaScript code to execute.
  output | Pointer to a string to be filled with the result value or nullptr if it is not needed. This parameter is new since wxWidgets version 3.1.1.

Returns
  true if there is a result, false if there is an error.

See also
  RunScriptAsync()

## ◆ RunScriptAsync()

virtual void wxWebView::RunScriptAsync | ( | const wxString & | javascript,
|  | void * | clientData = `nullptr`
| ) |  | const
| virtual

Runs the given JavaScript code asynchronously and returns the result via a `wxEVT_WEBVIEW_SCRIPT_RESULT`.

The script result value can be retrieved via wxWebViewEvent::GetString(). If the execution fails wxWebViewEvent::IsError() will return true. In this case additional script execution error information maybe available via wxWebViewEvent::GetString().

Parameters

  javascript | JavaScript code to execute.
  clientData | Arbirary pointer to data that can be retrieved from the result event.

Note
  The IE backend does not support async script execution.

Since
  3.1.6

See also
  RunScript()

## ◆ SelectAll()

virtual void wxWebView::SelectAll | ( |  | ) |
| virtual

Selects the entire page.

## ◆ SetEditable()

virtual void wxWebView::SetEditable | ( | bool | enable = `true` | ) |
| pure virtual

Set the editable property of the web control.

Enabling allows the user to edit the page even if the `contenteditable` attribute is not set. The exact capabilities vary with the backend being used.

Note
  This is not implemented for macOS and the Edge backend.

## ◆ SetPage() [1/2]

virtual void wxWebView::SetPage | ( | const wxString & | html,
|  | const wxString & | baseUrl
| ) |  |
| pure virtual

Set the displayed page source to the contents of the given string.

Parameters

  html | The string that contains the HTML data to display.
  baseUrl | URL assigned to the HTML data, to be used to resolve relative paths, for instance.

Note
  When using `wxWEBVIEW_BACKEND_IE` you must wait for the current page to finish loading before calling SetPage(). The baseURL parameter is not used in this backend and the Edge backend.

## ◆ SetPage() [2/2]

virtual void wxWebView::SetPage | ( | wxInputStream & | html,
|  | wxString | baseUrl
| ) |  |
| virtual

Set the displayed page source to the contents of the given stream.

Parameters

  html | The stream to read HTML data from.
  baseUrl | URL assigned to the HTML data, to be used to resolve relative paths, for instance.

## ◆ SetProxy()

virtual bool wxWebView::SetProxy | ( | const wxString & | proxy | ) |
| virtual

Set the proxy to use for all requests.

The proxy string must be a valid proxy specification, e.g. `http://my.local.proxy.corp:8080`

Currently this function is only implemented in WebKit2, Edge and Chromium backends and only WebKit2 backend allows to set the proxy after creating the webview, so it is recommended to call it before Create():

auto webview = wxWebView::New();
if ( !webview->SetProxy("http://127.0.0.1:8080") ) {
wxLogWarning("Setting proxy failed!");
}
webview->Create(parent, wxID_ANY);
wxWebView::New
static wxWebView * New(const wxString &backend=wxWebViewBackendDefault)
Factory function to create a new wxWebView with two-step creation, wxWebView::Create should be called...
wxID_ANY
@ wxID_ANY
Any id: means that we don't care about the id, whether when installing an event handler or when creat...
Definition: defs.h:591
wxLogWarning
void wxLogWarning(const char *formatString,...)
For warnings - they are also normally shown to the user, but don't interrupt the program work.

Returns
  true if proxy was set successfully or false if it failed, e.g. because this is not supported by the currently used backend.

## ◆ SetUserAgent()

virtual bool wxWebView::SetUserAgent | ( | const wxString & | userAgent | ) |
| virtual

Specify a custom user agent string for the web view.

Returns true the user agent could be set.

If your first request should already use the custom user agent please use two step creation and call SetUserAgent() before Create().

Note
  This is not implemented for IE.

Since
  3.1.5

## ◆ SetZoom()

virtual void wxWebView::SetZoom | ( | wxWebViewZoom | zoom | ) |
| virtual

Set the zoom level of the page.

See SetZoomFactor() for more precise scaling other than the measured steps provided by `wxWebViewZoom`.

Parameters

  zoom | How much to zoom (scale) the HTML document.

## ◆ SetZoomFactor()

virtual void wxWebView::SetZoomFactor | ( | float | zoom | ) |
| pure virtual

Set the zoom factor of the page.

Parameters

  zoom | How much to zoom (scale) the HTML document in arbitrary number.

Note
  zoom scale in IE will be converted into `wxWebViewZoom` levels for `wxWebViewZoomType` of `wxWEBVIEW_ZOOM_TYPE_TEXT`.

Since
  3.1.4

## ◆ SetZoomType()

virtual void wxWebView::SetZoomType | ( | wxWebViewZoomType | zoomType | ) |
| pure virtual

Set how to interpret the zoom factor.

Parameters

  zoomType | How the zoom factor should be interpreted by the backend.

Note
  invoke CanSetZoomType() first, some backends may not support all zoom types.

## ◆ ShowDevTools()

virtual bool wxWebView::ShowDevTools | ( |  | ) |
| virtual

Show the dev tools window.

Immediately open the dev tools window. Does nothing if this window was already open.

Unlike EnableAccessToDevTools(), which allows the user to open the dev tools window from the context menu, this function opens the same window programmatically.

Please note that while ShowDevTools() can be used whether access to the dev tools from the context menu was enabled or not, in WebKit2GTK+ backend calling it also enables interactive access to the dev tools from the context menu as a side effect.

Returns
  true if the dev tools window is shown (even if it had been already shown before this function was called), false if it could not be shown for some reason, most likely because the backend does not provide this functionality.

Note
  This function is not implemented in the IE and WebKit (GTK/macOS) backends (but is implemented for WebKit2 GTK backend).

Since
  3.3.0

## ◆ Stop()

virtual void wxWebView::Stop | ( |  | ) |
| pure virtual

Stop the current page loading process, if any.

May trigger an error event of type `wxWEBVIEW_NAV_ERR_USER_CANCELLED`. TODO: make `wxWEBVIEW_NAV_ERR_USER_CANCELLED` errors uniform across ports.

## ◆ Undo()

virtual void wxWebView::Undo | ( |  | ) |
| pure virtual

Undos the last action.